Bug 1302192 - upgrade to local x86_64.rpm, dnf wants to install i686 versions of a bunch of packages
upgrade to local x86_64.rpm, dnf wants to install i686 versions of a bunch of...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: dnf (Show other bugs)
25
Unspecified Unspecified
low Severity unspecified
: ---
: ---
Assigned To: rpm-software-management
Fedora Extras Quality Assurance
: Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-01-27 00:55 EST by Chris Murphy
Modified: 2016-07-27 06:22 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-27 06:22:39 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
dnf upgrade output (2.02 KB, text/plain)
2016-01-27 00:55 EST, Chris Murphy
no flags Details
debugdata.tar.bz2 (6.11 MB, application/x-bzip)
2016-01-27 00:57 EST, Chris Murphy
no flags Details

  None (edit)
Description Chris Murphy 2016-01-27 00:55:32 EST
Created attachment 1118683 [details]
dnf upgrade output

Description of problem:

Fedora 23 Server, up to date. I want to upgrade btrfs-progs-4.3.1-1.fc23.x86_64 with a newer package in koji btrfs-progs-4.4-1.fc23.x86_64.rpm. But dnf wants to install a bunch of i686 packages for no apparent reason.


Version-Release number of selected component (if applicable):
dnf-1.1.5-1.fc23.noarch
hawkey-0.6.2-3.fc23.x86_64
libhif-0.2.1-4.fc23.x86_64


How reproducible:
Always at the moment

Steps to Reproduce:
1. Download btrfs-progs-4.4-1.fc23.x86_64.rpm from koji, to a local directory such that it's the only rpm in the directory.
2. cd to that directory
3. sudo dnf upgrade *rpm

Actual results:

See "dnf upgrade output" attachment for the text I get. It wants to install a bunch of i686 stuff that already has x86_64 versions installed, very weird.

Expected results:

Only btrfs-progs-4.4-1.fc23.x86_64.rpm should be installed; I do this regularly, and haven't ever seen this behavior.


Additional info:

Attaching debugsolver also.
Comment 1 Chris Murphy 2016-01-27 00:57 EST
Created attachment 1118684 [details]
debugdata.tar.bz2
Comment 2 Chris Murphy 2016-01-27 01:04:13 EST
Very weird. This bug doesn't happen on a different system using Fedora 23 Workstation, also up to date. So I don't think it's the RPM itself. It's almost like the Fedora 23 Server dnf/rpm state is just confused for some reason.
Comment 3 Chris Murphy 2016-01-27 01:12:38 EST
Using -v

[chris@f23s ~]$ sudo dnf -v upgrade btrfs-progs-4.4-1.fc23.x86_64.rpm
cachedir: /var/cache/dnf
Loaded plugins: generate_completion_cache, Query, langpacks, copr, noroot, config-manager, protected_packages, reposync, needs-restarting, debuginfo-install, builddep, playground, download
Adding en to language list
Error reading file : /var/lib/dnf/plugins/langpacks/installed_langpacks as it does not exist
initialized Langpacks plugin
DNF version: 1.1.5
repo: using cache for: updates
repo: using cache for: fedora
not found deltainfo for: Fedora 23 - x86_64
not found updateinfo for: Fedora 23 - x86_64
updates: using metadata from Tue Jan 26 11:07:12 2016.
fedora: using metadata from Sat Oct 31 11:34:41 2015


Whhat? That last line says it's using metadata from October? I don't see how that's possible, this system was installed Dec 29, it's been dnf upgraded several times since then just fine.

I'm going to just leave it alone for now, if I try to fix it, the evidence of what's causing the problem might be erased. Seems like a bug in one way or another.
Comment 4 Chris Murphy 2016-01-31 01:45:51 EST
This is still a problem with dnf-1.1.6-1.fc23.noarch.


[root@f23s ~]# rpm -Uvvv /home/chris/btrfs-progs-4.4-1.fc23.x86_64.rpm 
ufdio:       1 reads,    15900 total bytes in 0.000027 secs
D: ============== /home/chris/btrfs-progs-4.4-1.fc23.x86_64.rpm
D: loading keyring from pubkeys in /var/lib/rpm/pubkeys/*.key
D: couldn't find any keys in /var/lib/rpm/pubkeys/*.key
D: loading keyring from rpmdb
D: opening  db environment /var/lib/rpm cdb:0x401
D: opening  db index       /var/lib/rpm/Packages 0x400 mode=0x0
D: locked   db index       /var/lib/rpm/Packages
D: opening  db index       /var/lib/rpm/Name 0x400 mode=0x0
D:  read h#     580 Header SHA1 digest: OK (44dfac3a3ed2ad52f6139c5313da593614f56803)
D: added key gpg-pubkey-34ec9cba-54e38751 to keyring
D: Using legacy gpg-pubkey(s) from rpmdb
D: Expected size:       603122 = lead(96)+sigs(4292)+pad(4)+data(598730)
D:   Actual size:       603122
D: /home/chris/btrfs-progs-4.4-1.fc23.x86_64.rpm: Header SHA1 digest: OK (ebeb3c5eb3624048b0e225e6527412bdcfa54c29)
ufdio:       6 reads,    24602 total bytes in 0.000041 secs
D: Plugin: calling hook init in systemd_inhibit plugin
D:  read h#     198 Header SHA1 digest: OK (2d3f5079e0381d3b4801ff2795dd1bfbc503f891)
D: 	added binary package [0]
D: found 0 source and 1 binary packages
D: opening  db index       /var/lib/rpm/Conflictname 0x400 mode=0x0
D: opening  db index       /var/lib/rpm/Requirename 0x400 mode=0x0
D: ========== +++ btrfs-progs-4.4-1.fc23 x86_64/linux 0x2
D: opening  db index       /var/lib/rpm/Basenames 0x400 mode=0x0
D:  read h#     467 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: /bin/sh                                       YES (db files)
D: opening  db index       /var/lib/rpm/Providename 0x400 mode=0x0
D:  read h#     729 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: ld-linux-x86-64.so.2()(64bit)                 YES (db provides)
D:  Requires: ld-linux-x86-64.so.2(GLIBC_2.3)(64bit)        YES (db provides)
D:  read h#     163 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: libblkid.so.1()(64bit)                        YES (db provides)
D:  Requires: libblkid.so.1(BLKID_1.0)(64bit)               YES (db provides)
D:  Requires: libblkid.so.1(BLKID_2.15)(64bit)              YES (db provides)
D:  Requires: libblkid.so.1(BLKID_2.17)(64bit)              YES (db provides)
D:  Requires: libc.so.6()(64bit)                            YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.14)(64bit)                  YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.2.5)(64bit)                 YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.3)(64bit)                   YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.3.3)(64bit)                 YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.3.4)(64bit)                 YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.4)(64bit)                   YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.6)(64bit)                   YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.7)(64bit)                   YES (db provides)
D:  Requires: libc.so.6(GLIBC_2.8)(64bit)                   YES (db provides)
D:  read h#     119 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: libcom_err.so.2()(64bit)                      YES (db provides)
D:  read h#     748 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: libext2fs.so.2()(64bit)                       YES (db provides)
D:  read h#     655 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: liblzo2.so.2()(64bit)                         YES (db provides)
D:  Requires: libpthread.so.0()(64bit)                      YES (db provides)
D:  Requires: libpthread.so.0(GLIBC_2.2.5)(64bit)           YES (db provides)
D:  Requires: libpthread.so.0(GLIBC_2.3.2)(64bit)           YES (db provides)
D:  Requires: libpthread.so.0(GLIBC_2.3.3)(64bit)           YES (db provides)
D:  read h#     434 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: libuuid.so.1()(64bit)                         YES (db provides)
D:  Requires: libuuid.so.1(UUID_1.0)(64bit)                 YES (db provides)
D:  read h#     231 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: libz.so.1()(64bit)                            YES (db provides)
D:  Requires: libz.so.1(ZLIB_1.2.0)(64bit)                  YES (db provides)
D:  Requires: rpmlib(CompressedFileNames) <= 3.0.4-1        YES (rpmlib provides)
D:  Requires: rpmlib(FileDigests) <= 4.6.0-1                YES (rpmlib provides)
D:  Requires: rpmlib(PayloadFilesHavePrefix) <= 4.0-1       YES (rpmlib provides)
D:  Requires: rpmlib(PayloadIsXz) <= 5.2-1                  YES (rpmlib provides)
D:  Requires: rtld(GNU_HASH)                                YES (db provides)
D: opening  db index       /var/lib/rpm/Obsoletename 0x400 mode=0x0
D: ========== --- btrfs-progs-4.3.1-1.fc23 x86_64/linux 0x2
D:  read h#     131 Header V3 RSA/SHA256 Signature, key ID 34ec9cba: OK
D:  Requires: btrfs-progs                                   YES (added provide)
D:  read h#     589 Header SHA1 digest: OK (0942f5b5b3aa9d6f9212716e3e09989f94306f0f)
D:  Requires: btrfs-progs = 4.3.1-1.fc23                    NO  
D:  Requires: libbtrfs.so.0()(64bit)                        YES (added provide)
error: Failed dependencies:
	btrfs-progs = 4.3.1-1.fc23 is needed by (installed) btrfs-progs-devel-4.3.1-1.fc23.x86_64
D: closed   db index       /var/lib/rpm/Packages
D: closed   db index       /var/lib/rpm/Obsoletename
D: closed   db index       /var/lib/rpm/Conflictname
D: closed   db index       /var/lib/rpm/Providename
D: closed   db index       /var/lib/rpm/Requirename
D: closed   db index       /var/lib/rpm/Basenames
D: closed   db index       /var/lib/rpm/Name
D: closed   db environment /var/lib/rpm


After using 'dnf remove btrfs-progs-devel' the command 'dnf upgrade btrfs-progs-4.4-1.fc23.x86_64.rpm' no long wants to drag in a bunch of i686 stuff. This is completely unexpected and non-intuitive.
Comment 5 Honza Silhan 2016-02-01 07:42:42 EST
Can you try whether this works on your machine?

# rpm -Uvvv /home/chris/btrfs-progs-4.4-1.fc23.x86_64.rpm btrfs-progs-devel--4.4-1.fc23.x86_64.rpm

The rpmdb could be corrupted if this happens on one machine only.
Comment 6 Chris Murphy 2016-02-01 13:51:29 EST
Originally only one of two systems had btrfs-devel installed (Server, not Workstation) which is why it only happened on one machine. I had forgotten it had -devel package installed, so I had not downloaded the -devel RPM from koji.

If I put Workstation into the same situation by downgrading btrfs-progs to 4.3.1, installing btrfs-progs-devel-4.3.1, then trying dnf upgrade btrfs-progs-4.4-1.fc23.x86_64.rpm only, I get the same problem where dnf doesn't tell me about -devel at all, it just tries to drag in i686 stuff. So it's not happening on just one system.
Comment 7 Honza Silhan 2016-02-08 07:21:50 EST
We'll investigate.
Comment 8 Fedora Admin XMLRPC Client 2016-07-08 05:35:35 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 9 Jan Kurik 2016-07-26 01:02:32 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.
Comment 10 Igor Gnatenko 2016-07-27 06:22:39 EDT
if still reproducible - reopen please.

Note You need to log in before you can comment on or make changes to this bug.